Attribute VB_Name = "Module1"
Sub CreateScatterPlotWithTrendlines()
    Dim sourceSheet As Worksheet
    Dim chartSheet As Worksheet
    Dim i As Integer
    Dim chartObj As ChartObject
    Dim chart As chart
    
    ' Define the source sheet and column names
    Set sourceSheet = ThisWorkbook.Sheets("output") ' Replace "output" with your sheet name
    
    ' Define the chart sheet
    Set chartSheet = ThisWorkbook.Sheets.Add(After:=Sheets(Sheets.Count))
    
    ' Create a scatter plot with trendlines
    Set chartObj = chartSheet.ChartObjects.Add(Left:=10, Width:=1000, Top:=10, Height:=300)
    Set chart = chartObj.chart
    
    With chart
        .ChartType = xlXYScatter
        .HasLegend = True
        
        ' Set x-axis label
        .Axes(xlCategory).HasTitle = True
        .Axes(xlCategory).AxisTitle.Text = "freq[Hz]"
        
        ' Set y-axis label
        .Axes(xlValue).HasTitle = True
        .Axes(xlValue).AxisTitle.Text = "Df"
        
        ' Set chart title
        .HasTitle = True
        .ChartTitle.Text = "Df over freq dimension 600um"
        j = 1
        ' Loop through the series
        For i = 1 To 31 ' Adjust the loop count as needed for the number of series
            Dim xRange As Range
            Dim yRange As Range
            Dim seriesRange As Range
            
            ' Set the X-axis range
            Set xRange = sourceSheet.Range(sourceSheet.Cells(2, i), sourceSheet.Cells(96, i))
            
            ' Set the Y-axis range
            Set yRange = sourceSheet.Range(sourceSheet.Cells(2, i + 1), sourceSheet.Cells(96, i + 1))
            
            ' Set the series name
            Dim seriesName As String
            seriesName = sourceSheet.Cells(1, i + 3).Value
            
            ' Combine the X-axis and Y-axis ranges into a series range
            Set seriesRange = Union(xRange, yRange)
            
            ' Add the series to the chart
            .SeriesCollection.NewSeries
            .SeriesCollection(j).Values = yRange
            .SeriesCollection(j).XValues = xRange
            .SeriesCollection(j).Name = seriesName
            
            ' Set marker style and size
            .SeriesCollection(j).MarkerStyle = xlMarkerStyleCircle
            .SeriesCollection(j).MarkerSize = 2
            
            j = j + 1
            i = i + 3
        Next i
        
        ' Add legend
        .HasLegend = True
        .Legend.Position = xlLegendPositionRight
        
    End With
    
    ' Clean up
    Set sourceSheet = Nothing
    Set chartSheet = Nothing
    Set chartObj = Nothing
    Set chart = Nothing
End Sub

